{ Include file for XAudio/FreePascal unit }
{ by Udo Giacomozzi 1999                  }


type
  HWND = DWORD;

const
{ Messages }
  XA_MSG_BASE                              = $9000;
  XA_MSG_UNKNOWN                           = 0;
  XA_MSG_COMMAND_EXIT                      = 1;
  XA_MSG_COMMAND_PING                      = 2;
  XA_MSG_COMMAND_PLAY                      = 3;
  XA_MSG_COMMAND_PAUSE                     = 4;
  XA_MSG_COMMAND_STOP                      = 5;
  XA_MSG_COMMAND_SEEK                      = 6;
  XA_MSG_COMMAND_INPUT_OPEN                = 7;
  XA_MSG_COMMAND_INPUT_CLOSE               = 8;
  XA_MSG_COMMAND_INPUT_SEND_MESSAGE        = 9;
  XA_MSG_COMMAND_INPUT_ADD_FILTER          = 10;
  XA_MSG_COMMAND_INPUT_REMOVE_FILTER       = 11;
  XA_MSG_COMMAND_INPUT_FILTERS_LIST        = 12;
  XA_MSG_COMMAND_INPUT_MODULE_REGISTER     = 13;
  XA_MSG_COMMAND_INPUT_MODULE_QUERY        = 14;
  XA_MSG_COMMAND_INPUT_MODULES_LIST        = 15;
  XA_MSG_COMMAND_OUTPUT_OPEN               = 16;
  XA_MSG_COMMAND_OUTPUT_CLOSE              = 17;
  XA_MSG_COMMAND_OUTPUT_SEND_MESSAGE       = 18;
  XA_MSG_COMMAND_OUTPUT_MUTE               = 19;
  XA_MSG_COMMAND_OUTPUT_UNMUTE             = 20;
  XA_MSG_COMMAND_OUTPUT_RESET              = 21;
  XA_MSG_COMMAND_OUTPUT_DRAIN              = 22;
  XA_MSG_COMMAND_OUTPUT_ADD_FILTER         = 23;
  XA_MSG_COMMAND_OUTPUT_REMOVE_FILTER      = 24;
  XA_MSG_COMMAND_OUTPUT_FILTERS_LIST       = 25;
  XA_MSG_COMMAND_OUTPUT_MODULE_REGISTER    = 26;
  XA_MSG_COMMAND_OUTPUT_MODULE_QUERY       = 27;
  XA_MSG_COMMAND_OUTPUT_MODULES_LIST       = 28;
  XA_MSG_SET_PLAYER_MODE                   = 29;
  XA_MSG_GET_PLAYER_MODE                   = 30;
  XA_MSG_SET_PLAYER_ENVIRONMENT_INTEGER    = 31;
  XA_MSG_GET_PLAYER_ENVIRONMENT_INTEGER    = 32;
  XA_MSG_SET_PLAYER_ENVIRONMENT_STRING     = 33;
  XA_MSG_GET_PLAYER_ENVIRONMENT_STRING     = 34;
  XA_MSG_UNSET_PLAYER_ENVIRONMENT          = 35;
  XA_MSG_SET_INPUT_NAME                    = 36;
  XA_MSG_GET_INPUT_NAME                    = 37;
  XA_MSG_SET_INPUT_MODULE                  = 38;
  XA_MSG_GET_INPUT_MODULE                  = 39;
  XA_MSG_SET_INPUT_POSITION_RANGE          = 40;
  XA_MSG_GET_INPUT_POSITION_RANGE          = 41;
  XA_MSG_SET_INPUT_TIMECODE_GRANULARITY    = 42;
  XA_MSG_GET_INPUT_TIMECODE_GRANULARITY    = 43;
  XA_MSG_SET_OUTPUT_NAME                   = 44;
  XA_MSG_GET_OUTPUT_NAME                   = 45;
  XA_MSG_SET_OUTPUT_MODULE                 = 46;
  XA_MSG_GET_OUTPUT_MODULE                 = 47;
  XA_MSG_SET_OUTPUT_VOLUME                 = 48;
  XA_MSG_GET_OUTPUT_VOLUME                 = 49;
  XA_MSG_SET_OUTPUT_CHANNELS               = 50;
  XA_MSG_GET_OUTPUT_CHANNELS               = 51;
  XA_MSG_SET_OUTPUT_PORTS                  = 52;
  XA_MSG_GET_OUTPUT_PORTS                  = 53;
  XA_MSG_SET_CODEC_QUALITY                 = 54;
  XA_MSG_GET_CODEC_QUALITY                 = 55;
  XA_MSG_SET_OUTPUT_FEEDBACK_RATE          = 56;
  XA_MSG_GET_OUTPUT_FEEDBACK_RATE          = 57;
  XA_MSG_SET_CODEC_EQUALIZER               = 58;
  XA_MSG_GET_CODEC_EQUALIZER               = 59;
  XA_MSG_SET_NOTIFICATION_MASK             = 60;
  XA_MSG_GET_NOTIFICATION_MASK             = 61;
  XA_MSG_SET_DEBUG_LEVEL                   = 62;
  XA_MSG_GET_DEBUG_LEVEL                   = 63;
  XA_MSG_NOTIFY_READY                      = 64;
  XA_MSG_NOTIFY_ACK                        = 65;
  XA_MSG_NOTIFY_NACK                       = 66;
  XA_MSG_NOTIFY_PONG                       = 67;
  XA_MSG_NOTIFY_EXITED                     = 68;
  XA_MSG_NOTIFY_PLAYER_STATE               = 69;
  XA_MSG_NOTIFY_PLAYER_MODE                = 70;
  XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_INTEGER = 71;
  XA_MSG_NOTIFY_PLAYER_ENVIRONMENT_STRING  = 72;
  XA_MSG_NOTIFY_INPUT_STATE                = 73;
  XA_MSG_NOTIFY_INPUT_NAME                 = 74;
  XA_MSG_NOTIFY_INPUT_CAPS                 = 75;
  XA_MSG_NOTIFY_INPUT_POSITION             = 76;
  XA_MSG_NOTIFY_INPUT_POSITION_RANGE       = 77;
  XA_MSG_NOTIFY_INPUT_TIMECODE             = 78;
  XA_MSG_NOTIFY_INPUT_TIMECODE_GRANULARITY = 79;
  XA_MSG_NOTIFY_INPUT_DURATION             = 80;
  XA_MSG_NOTIFY_INPUT_STREAM_INFO          = 81;
  XA_MSG_NOTIFY_INPUT_MODULE               = 82;
  XA_MSG_NOTIFY_INPUT_MODULE_INFO          = 83;
  XA_MSG_NOTIFY_INPUT_DEVICE_INFO          = 84;
  XA_MSG_NOTIFY_INPUT_FILTER_INFO          = 85;
  XA_MSG_NOTIFY_OUTPUT_STATE               = 86;
  XA_MSG_NOTIFY_OUTPUT_NAME                = 87;
  XA_MSG_NOTIFY_OUTPUT_CAPS                = 88;
  XA_MSG_NOTIFY_OUTPUT_VOLUME              = 89;
  XA_MSG_NOTIFY_OUTPUT_BALANCE             = 90;
  XA_MSG_NOTIFY_OUTPUT_PCM_LEVEL           = 91;
  XA_MSG_NOTIFY_OUTPUT_MASTER_LEVEL        = 92;
  XA_MSG_NOTIFY_OUTPUT_CHANNELS            = 93;
  XA_MSG_NOTIFY_OUTPUT_PORTS               = 94;
  XA_MSG_NOTIFY_OUTPUT_FEEDBACK_RATE       = 95;
  XA_MSG_NOTIFY_OUTPUT_MODULE              = 96;
  XA_MSG_NOTIFY_OUTPUT_MODULE_INFO         = 97;
  XA_MSG_NOTIFY_OUTPUT_DEVICE_INFO         = 98;
  XA_MSG_NOTIFY_OUTPUT_FILTER_INFO         = 99;
  XA_MSG_NOTIFY_CODEC_QUALITY              = 100;
  XA_MSG_NOTIFY_CODEC_EQUALIZER            = 101;
  XA_MSG_NOTIFY_NOTIFICATION_MASK          = 102;
  XA_MSG_NOTIFY_DEBUG_LEVEL                = 103;
  XA_MSG_NOTIFY_PROGRESS                   = 104;
  XA_MSG_NOTIFY_DEBUG                      = 105;
  XA_MSG_NOTIFY_ERROR                      = 106;

{ Player State }
  XA_PLAYER_STATE_STOPPED                  = 0;
  XA_PLAYER_STATE_PLAYING                  = 1;
  XA_PLAYER_STATE_PAUSED                   = 2;
  XA_PLAYER_STATE_EOF                      = 3;

{ Input State }
  XA_INPUT_STATE_OPEN                      = 0;
  XA_INPUT_STATE_CLOSED                    = 1;

{ Output State }
  XA_OUTPUT_STATE_OPEN                     = 0;
  XA_OUTPUT_STATE_CLOSED                   = 1;

{ Channel Configurations }
  XA_OUTPUT_CHANNELS_STEREO                = 0;
  XA_OUTPUT_CHANNELS_MONO_LEFT             = 1;
  XA_OUTPUT_CHANNELS_MONO_RIGHT            = 2;
  XA_OUTPUT_CHANNELS_MONO_MIX              = 3;

{ Player Modes }
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_STOP      = 1;
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_PAUSE     = 2;
  XA_PLAYER_MODE_OUTPUT_AUTO_CLOSE_ON_EOF       = 4;

{ Notification Masks }
  XA_NOTIFY_MASK_ERROR                          = $0000001;
  XA_NOTIFY_MASK_DEBUG                          = $0000002;
  XA_NOTIFY_MASK_PROGRESS                       = $0000004;
  XA_NOTIFY_MASK_ACK                            = $0000008;
  XA_NOTIFY_MASK_NACK                           = $0000010;
  XA_NOTIFY_MASK_PLAYER_STATE                   = $0000020;
  XA_NOTIFY_MASK_INPUT_STATE                    = $0000040;
  XA_NOTIFY_MASK_INPUT_NAME                     = $0000080;
  XA_NOTIFY_MASK_INPUT_CAPS                     = $0000100;
  XA_NOTIFY_MASK_INPUT_DURATION                 = $0000200;
  XA_NOTIFY_MASK_INPUT_POSITION                 = $0000400;
  XA_NOTIFY_MASK_INPUT_POSITION_RANGE           = $0000800;
  XA_NOTIFY_MASK_INPUT_TIMECODE                 = $0001000;
  XA_NOTIFY_MASK_INPUT_TIMECODE_GRANULARITY     = $0002000;
  XA_NOTIFY_MASK_INPUT_STREAM_INFO              = $0004000;
  XA_NOTIFY_MASK_OUTPUT_STATE                   = $0008000;
  XA_NOTIFY_MASK_OUTPUT_NAME                    = $0010000;
  XA_NOTIFY_MASK_OUTPUT_CAPS                    = $0020000;
  XA_NOTIFY_MASK_OUTPUT_VOLUME                  = $0040000;
  XA_NOTIFY_MASK_OUTPUT_BALANCE                 = $0080000;
  XA_NOTIFY_MASK_OUTPUT_PCM_LEVEL               = $0100000;
  XA_NOTIFY_MASK_OUTPUT_MASTER_LEVEL            = $0200000;
  XA_NOTIFY_MASK_OUTPUT_PORTS                   = $0400000;
  XA_NOTIFY_MASK_CODEC_EQUALIZER                = $0800000;
  XA_NOTIFY_MASK_FEEDBACK_EVENT                 = $1000000;

{ Input Caps }
  XA_DECODER_INPUT_SEEKABLE                  = $0001;

{ Output Caps }
  XA_DECODER_DEVICE_HAS_MASTER_LEVEL_CONTROL = $0000001;
  XA_DECODER_DEVICE_HAS_PCM_LEVEL_CONTROL    = $0000002;
  XA_DECODER_DEVICE_HAS_BALANCE_CONTROL      = $0000004;
  XA_DECODER_DEVICE_HAS_LINE_OUT             = $0000008;
  XA_DECODER_DEVICE_HAS_SPEAKER_OUT          = $0000010;
  XA_DECODER_DEVICE_HAS_HEADPHONE_OUT        = $0000020;
  XA_DECODER_DEVICE_HAS_MONO_16_00_KHZ       = $0000080;
  XA_DECODER_DEVICE_HAS_MONO_22_05_KHZ       = $0000100;
  XA_DECODER_DEVICE_HAS_MONO_24_00_KHZ       = $0000200;
  XA_DECODER_DEVICE_HAS_MONO_32_00_KHZ       = $0000400;
  XA_DECODER_DEVICE_HAS_MONO_44_10_KHZ       = $0000800;
  XA_DECODER_DEVICE_HAS_MONO_48_00_KHZ       = $0001000;
  XA_DECODER_DEVICE_HAS_STEREO_16_00_KHZ     = $0002000;
  XA_DECODER_DEVICE_HAS_STEREO_22_05_KHZ     = $0004000;
  XA_DECODER_DEVICE_HAS_STEREO_24_00_KHZ     = $0008000;
  XA_DECODER_DEVICE_HAS_STEREO_32_00_KHZ     = $0010000;
  XA_DECODER_DEVICE_HAS_STEREO_44_10_KHZ     = $0020000;
  XA_DECODER_DEVICE_HAS_STEREO_48_00_KHZ     = $0040000;
  XA_DECODER_DEVICE_HAS_8_BITS               = $0080000;
  XA_DECODER_DEVICE_HAS_MU_LAW               = $0100000;
  XA_DECODER_DEVICE_HAS_16_BITS              = $0200000;
  XA_DECODER_DEVICE_HAS_MUTE                 = $0400000;
  XA_DECODER_DEVICE_HAS_RESET                = $0800000;
  XA_DECODER_DEVICE_HAS_PAUSE                = $1000000;
  XA_DECODER_DEVICE_HAS_DRAIN                = $2000000;
  XA_DECODER_DEVICE_HAS_BUFFER_STATUS        = $4000000;

{ Output Ports }
  XA_DECODER_CONTROL_OUTPUT_LINE             = $01;
  XA_DECODER_CONTROL_OUTPUT_SPEAKER          = $02;
  XA_DECODER_CONTROL_OUTPUT_HEADPHONE        = $04;

{ Environment Variables }
  XA_DECODER_ENVIRONMENT_MAX_NAME_LENGTH     = 256;
  XA_DECODER_ENVIRONMENT_MAX_STRING_LENGTH   = 1024;

{ Input Device Flags }
  XA_DECODER_INPUT_QUERY_NAME_IS_GENERIC     = $01;
  XA_DECODER_INPUT_QUERY_DEVICE_IS_DEFAULT   = $02;

{ Output Device Flags }
  XA_DECODER_OUTPUT_QUERY_NAME_IS_GENERIC     = $01;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_DEFAULT   = $02;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_SHAREABLE = $04;

{ Modules }
  XA_DECODER_INPUT_AUTOSELECT              = -1;
  XA_DECODER_OUTPUT_AUTOSELECT             = -1;

{ Filters }
  XA_DECODER_INPUT_FILTER_FIRST            = -1;
  XA_DECODER_INPUT_FILTER_LAST             =  0;
  XA_DECODER_INPUT_FILTER_BY_NAME          = -2;

  XA_DECODER_OUTPUT_FILTER_FIRST           = -1;
  XA_DECODER_OUTPUT_FILTER_LAST            =  0;
  XA_DECODER_OUTPUT_FILTER_BY_NAME         = -2;

{ Priorities }
  XA_CONTROL_PRIORITY_LOWEST               = 0;
  XA_CONTROL_PRIORITY_LOW                  = 1;
  XA_CONTROL_PRIORITY_NORMAL               = 2;
  XA_CONTROL_PRIORITY_HIGH                 = 3;
  XA_CONTROL_PRIORITY_HIGHEST              = 4;

  XA_DECODER_CODEC_QUALITY_HIGH            = 0;
  XA_DECODER_CODEC_QUALITY_MEDIUM          = 1;
  XA_DECODER_CODEC_QUALITY_LOW             = 2;

{ API Ids }
  XA_API_ID_SYNC  = 1;
  XA_API_ID_ASYNC = 2;

{ Misc Constants }
  XA_OUTPUT_VOLUME_IGNORE_FIELD            = 255;

  XA_DECODER_MAX_NAME_LENGTH               = 255;
  XA_DECODER_MAX_DESCRIPTION_LENGTH        = 255;

{ API Version }
  XA_ASYNC_API_MAJOR = 3;
  XA_ASYNC_API_MINOR = 2;

{ Types }
type
  XA_EnvironmentInfo = record
    name: PChar;
    case Integer of
      0: (integer_value: LongInt);
      1: (string_value:   PChar);
  end;

  XA_TimecodeInfo = record
    h: Byte;
    m: Byte;
    s: Byte;
    f: Byte;
  end;

  XA_NackInfo = record
    command: Byte;
    code:    SmallInt;
  end;

  XA_VolumeInfo = record
    master_level: Byte;
    pcm_level:    Byte;
    balance:      Byte;
  end;

  XA_PositionInfo = record
    offset: Cardinal;
    range:  Cardinal;
  end;

  XA_ModuleInfo = record
    id:          Byte;
    nb_devices:  Byte;
    name:        PChar;
    description: PChar;
  end;

  XA_FilterInfo = record
    name: PChar;
    id:   Word;
  end;

  XA_DeviceInfo = record
    module_id:   Byte;
    index:       Byte;
    flags:       Byte;
    name:        PChar;
    description: PChar;
  end;

  XA_StreamInfo = record
    level:     Byte;
    layer:     Byte;
    bitrate:   Word;
    frequency: Word;
    mode:      Byte;
  end;

  XA_ModuleMessage = record
    message_type: Word;
    size:         Word;
    data:         Pointer;
  end;

  XA_ProgressInfo = record
    source:  Byte;
    code:    Byte;
    value:   SmallInt;
    msg:     PChar;
  end;

  XA_DebugInfo = record
    source:  Byte;
    level:   Byte;
    msg:     PChar;
  end;

  XA_ErrorInfo = record
    source: Byte;
    code:   SmallInt;
    msg:    PChar;
  end;

  XA_EqualizerInfo = record
    left:  array[0..31] of ShortInt;
    right: array[0..31] of ShortInt;
  end;
  PXA_EqualizerInfo = ^XA_EqualizerInfo;

  XA_Message = record
    code: Integer;
    case Integer of
      0:  (buffer:           Pchar);
      1:  (name:             PChar);
      2:  (module_id:        SmallInt);
      3:  (state:            Byte);
      4:  (mode:             Cardinal);
      5:  (channels:         Byte);
      6:  (quality:          Byte);
      7:  (duration:         Cardinal);
      8:  (range:            Cardinal);
      9:  (granularity:      Cardinal);
      10: (caps:             Cardinal);
      11: (ports:            Byte);
      12: (ack:              Byte);
      13: (tag:              Cardinal);
      14: (debug_level:      Byte);
      15: (notification_mask:Cardinal);
      16: (rate:             Byte);
      17: (nack:             XA_NackInfo);
      18: (volume:           XA_VolumeInfo);
      19: (position:         XA_PositionInfo);
      20: (equalizer:       ^XA_EqualizerInfo);
      21: (module_info:      XA_ModuleInfo);
      22: (filter_info:      XA_FilterInfo);
      23: (device_info:      XA_DeviceInfo);
      24: (stream_info:      XA_StreamInfo);
      25: (environment_info: XA_EnvironmentInfo);
      26: (timecode:         XA_TimecodeInfo);
      27: (module_message:   XA_ModuleMessage);
      28: (progress:         XA_ProgressInfo);
      29: (debug:            XA_DebugInfo);
      30: (error:            XA_ErrorInfo);
  end;

    {----------------------------------------------------------------------
    |       error codes
    +--------------------------------------------------------------------- }
    const
       XA_SUCCESS = 0;
       XA_FAILURE = -(1);
    { general error codes  }
       XA_ERROR_BASE_GENERAL = -(100);
       XA_ERROR_OUT_OF_MEMORY = XA_ERROR_BASE_GENERAL - 0;
       XA_ERROR_INVALID_PARAMETERS = XA_ERROR_BASE_GENERAL - 1;
       XA_ERROR_INTERNAL = XA_ERROR_BASE_GENERAL - 2;
       XA_ERROR_TIMEOUT = XA_ERROR_BASE_GENERAL - 3;
       XA_ERROR_VERSION_EXPIRED = XA_ERROR_BASE_GENERAL - 4;
    { network error codes  }
       XA_ERROR_BASE_NETWORK = -(200);
       XA_ERROR_CONNECT_TIMEOUT = XA_ERROR_BASE_NETWORK - 0;
       XA_ERROR_CONNECT_FAILED = XA_ERROR_BASE_NETWORK - 1;
       XA_ERROR_CONNECTION_REFUSED = XA_ERROR_BASE_NETWORK - 2;
       XA_ERROR_ACCEPT_FAILED = XA_ERROR_BASE_NETWORK - 3;
       XA_ERROR_LISTEN_FAILED = XA_ERROR_BASE_NETWORK - 4;
       XA_ERROR_SOCKET_FAILED = XA_ERROR_BASE_NETWORK - 5;
       XA_ERROR_SOCKET_CLOSED = XA_ERROR_BASE_NETWORK - 6;
       XA_ERROR_BIND_FAILED = XA_ERROR_BASE_NETWORK - 7;
       XA_ERROR_HOST_UNKNOWN = XA_ERROR_BASE_NETWORK - 8;
       XA_ERROR_HTTP_INVALID_REPLY = XA_ERROR_BASE_NETWORK - 9;
       XA_ERROR_HTTP_ERROR_REPLY = XA_ERROR_BASE_NETWORK - 10;
       XA_ERROR_HTTP_FAILURE = XA_ERROR_BASE_NETWORK - 11;
       XA_ERROR_FTP_INVALID_REPLY = XA_ERROR_BASE_NETWORK - 12;
       XA_ERROR_FTP_ERROR_REPLY = XA_ERROR_BASE_NETWORK - 13;
       XA_ERROR_FTP_FAILURE = XA_ERROR_BASE_NETWORK - 14;
    { control error codes  }
       XA_ERROR_BASE_CONTROL = -(300);
       XA_ERROR_PIPE_FAILED = XA_ERROR_BASE_CONTROL - 0;
       XA_ERROR_FORK_FAILED = XA_ERROR_BASE_CONTROL - 1;
       XA_ERROR_SELECT_FAILED = XA_ERROR_BASE_CONTROL - 2;
       XA_ERROR_PIPE_CLOSED = XA_ERROR_BASE_CONTROL - 3;
       XA_ERROR_PIPE_READ_FAILED = XA_ERROR_BASE_CONTROL - 4;
       XA_ERROR_PIPE_WRITE_FAILED = XA_ERROR_BASE_CONTROL - 5;
       XA_ERROR_INVALID_MESSAGE = XA_ERROR_BASE_CONTROL - 6;
       XA_ERROR_CIRQ_FULL = XA_ERROR_BASE_CONTROL - 7;
       XA_ERROR_POST_FAILED = XA_ERROR_BASE_CONTROL - 8;
    { url error codes  }
       XA_ERROR_BASE_URL = -(400);
       XA_ERROR_URL_UNSUPPORTED_SCHEME = XA_ERROR_BASE_URL - 0;
       XA_ERROR_URL_INVALID_SYNTAX = XA_ERROR_BASE_URL - 1;
    { i/o error codes  }
       XA_ERROR_BASE_IO = -(500);
       XA_ERROR_OPEN_FAILED = XA_ERROR_BASE_IO - 0;
       XA_ERROR_CLOSE_FAILED = XA_ERROR_BASE_IO - 1;
       XA_ERROR_READ_FAILED = XA_ERROR_BASE_IO - 2;
       XA_ERROR_WRITE_FAILED = XA_ERROR_BASE_IO - 3;
       XA_ERROR_PERMISSION_DENIED = XA_ERROR_BASE_IO - 4;
       XA_ERROR_NO_DEVICE = XA_ERROR_BASE_IO - 5;
       XA_ERROR_IOCTL_FAILED = XA_ERROR_BASE_IO - 6;
       XA_ERROR_MODULE_NOT_FOUND = XA_ERROR_BASE_IO - 7;
       XA_ERROR_UNSUPPORTED_INPUT = XA_ERROR_BASE_IO - 8;
       XA_ERROR_UNSUPPORTED_OUTPUT = XA_ERROR_BASE_IO - 9;
       XA_ERROR_DEVICE_BUSY = XA_ERROR_BASE_IO - 10;
       XA_ERROR_NO_SUCH_DEVICE = XA_ERROR_BASE_IO - 11;
       XA_ERROR_NO_SUCH_FILE = XA_ERROR_BASE_IO - 12;
       XA_ERROR_INPUT_EOF = XA_ERROR_BASE_IO - 13;
    { bitstream error codes  }
       XA_ERROR_BASE_BITSTREAM = -(600);
       XA_ERROR_INVALID_FRAME = XA_ERROR_BASE_BITSTREAM - 0;
    { dynamic linking error codes  }
       XA_ERROR_BASE_DYNLINK = -(700);
       XA_ERROR_DLL_NOT_FOUND = XA_ERROR_BASE_DYNLINK - 0;
       XA_ERROR_SYMBOL_NOT_FOUND = XA_ERROR_BASE_DYNLINK - 1;
    { environment variables error codes  }
       XA_ERROR_BASE_ENVIRONMENT = -(800);
       XA_ERROR_NO_SUCH_ENVIRONMENT = XA_ERROR_BASE_ENVIRONMENT - 0;
       XA_ERROR_ENVIRONMENT_TYPE_MISMATCH = XA_ERROR_BASE_ENVIRONMENT - 1;
    {----------------------------------------------------------------------
    |       error strings
    +--------------------------------------------------------------------- }
{ C++ extern C conditionnal removed }
(* Const before type ignored *)
(* error
extern "C" {
#endif
 in declarator_list *)
(* error
#endif

 in declarator_list *)
{ C++ end of extern C conditionnal removed }
    { __XAUDIO_H__  }